#pragma once

#ifdef _WIN32_WINNT
#undef _WIN32_WINNT
#endif
#define _WIN32_WINNT 0x0500

//#define USE_SMART_PTRS

#include "orbitersdk.h"
//#include "UMmuSDK.h"
#include "XRVesselCtrl.h"
//#include "PayloadManager.h"
//#include "OrbiterSoundSDK35.h"
//#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <list>
#include <io.h>

using namespace std;

typedef enum { PLANT_BASE, DEPOT_BASE, PLANT_VESSEL, DEPOT_VESSEL } FacilityType;

#define ALL_EXPOSED 0
#define VESSEL_NAME_EXISTS 1
#define STORAGE_NOT_FOUND 2
#define NOTHING_TO_EXPOSE 3
#define VESSEL_NOT_INSTALLED 4
#define NO_PLACE 5
#define ALL_INDEXES_USED 6
#define NO_SELECTED_FACILITY 7

#ifdef USE_SMART_PTRS

/*typedef shared_ptr<Product> ProductPtr;
typedef shared_ptr<PlantBase> PlantBasePtr;
typedef shared_ptr<DepotBase> DepotBasePtr;*/

#define ProductPtr shared_ptr<Product>
#define PlantBasePtr shared_ptr<PlantBase>
#define DepotBasePtr shared_ptr<DepotBase>
#define StoragePtr shared_ptr<Storage>

/*class {
public:
	template<typename T>
	operator shared_ptr<T>() { return shared_ptr<T>(); }
} NullPtr;*/

#else

#define ProductPtr Product*
#define PlantBasePtr PlantBase*
#define DepotBasePtr DepotBase*
#define StoragePtr Storage*

//#define NullPtr NULL

#endif


//typedef struct {
//	string message;
//	COLORREF color;
//} Message;
