#pragma once

#include "Common.h"
#include "Utils.h"
#include "DepotBase.h"
#include "Plant.h"

class PlantBase : public Plant, public DepotBase
{
public:
	PlantBase(void);
	PlantBase(OBJHANDLE cBody);
	~PlantBase(void);

	static PlantBasePtr Create(OBJHANDLE cBody);
	static PlantBasePtr Null;
	static PlantBasePtr Cast(DepotBasePtr);
};

