#pragma once

#include "Common.h"
#include "Utils.h"
#include "Product.h"
#include "Storage.h"

class Depot
{
public:
	Depot(void);
	~Depot(void);
	
	void SetName(string name);
	string GetName();

	void AddStorage(StoragePtr storage);
	int GetStorageCount();
	StoragePtr GetStorage(int index);
	StoragePtr GetStorage(const string& productId);

	virtual bool IsPlant() {return false;}

protected:

	string _name;

	vector<StoragePtr> _storages;
};
